
#property copyright " 2005-2006 RickD"
#property link      "www.e2e-fx.net"
#property show_inputs

#define major   2
#define minor   1

#include <stdlib.mqh>
#include <stderror.mqh>

#import "mt4m.dll"
  int ErrorCode();
  string ErrorMsg();
  bool Init(string root, string acc);
  bool Write();
  void SetCmd(int val);
  void SetTicket(int val);
  void SetType(int val);
  void SetSymbol(string val);
  void SetLot(double val);
  void SetOpenPrice(double val);
  void SetSL(double val);
  void SetTP(double val);
  void SetClosePrice(double val);
  void SetTimeLocal(int tm);
  void SetTimeServer(int tm);
#import

#import "IniFile.dll"
  bool ReadFile(string path);
  string GetValue(string key_name, string value_name, string def_value);
  int GetValueI(string key_name, string value_name, int def_value);
  double GetValueF(string key_name, string value_name, double def_value);
#import


#define   SET       1
#define   MODIFY    2
#define   CLOSE     3


int       COUNT = 0;
int       Ticket[1000];
int       Type[1000];
string    Sym[1000];
double    Lot[1000];
double    PriceO[1000];
double    SL[1000];
double    TP[1000];

extern string IniPath = "D:\\MT4\\mc\\mt4m.ini";

int Timer = 0;
string Root = "";
bool inited = false;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

void init () {
  Comment("");
  
  bool res = ReadFile(IniPath);
  if (!res) {
    Print("*** Cannot open ini file! ***");
    return;
  }

  Root = GetValue("Main", "Root", "");
    
  res = Init(Root, AccountNumber());
  int err = ErrorCode();
  if (err == -1) {
    Print("*** ", ErrorMsg(), " ***");
    return;
  }
  
  
  int cnt = OrdersTotal();
  for (int i = 0; i < cnt; i++) {
    if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) continue;
    
    NewOrder(OrderTicket(), false);
  }
  
  inited = true;
}

void deinit() {
  Comment("");
}

void start() {

  if (!inited) return;

  while (!IsStopped()) {
    Comment(
      "MT4 Master ", major, ".", minor, 
      "\nTime: ", TimeToStr(LocalTime(), TIME_DATE|TIME_SECONDS));

    bool res = ReadFile(IniPath);
    if (!res) {
      Print("*** Cannot open ini file! ***");
      break;
    }

    Timer = GetValueI("Main", "Timer", 3);

    main();
    
    Sleep(Timer);
  }
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

void main()
{
  int cnt = OrdersTotal();
  for (int i = 0; i < cnt; i++) {
    if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) continue;

    int ind = GetOrder(OrderTicket());
    
    if (ind == -1)
      NewOrder(OrderTicket());
    else
      CheckModified(ind, OrderTicket());
  }
  
  cnt = OrdersHistoryTotal();
  for (i = 0; i < cnt; i++) {
    if (!OrderSelect(i, SELECT_BY_POS, MODE_HISTORY)) continue;

    ind = GetOrder(OrderTicket());
    if (ind >= 0) RemoveOrder(ind, OrderTicket());
  }  
}

int GetOrder(int ticket) 
{
  for (int i=0; i<COUNT; i++) {
    if (Ticket[i] == ticket) return (i);
  }
  
  return (-1);
}

bool NewOrder(int ticket, bool SendCmd=true)
{
  Ticket[COUNT] = ticket;
  Type[COUNT] = OrderType();
  Sym[COUNT] = OrderSymbol();
  Lot[COUNT] = OrderLots();
  PriceO[COUNT] = OrderOpenPrice();
  SL[COUNT] = OrderStopLoss();
  TP[COUNT] = OrderTakeProfit();
  COUNT++;
  
  if (!SendCmd) return (true);

  SetCmd(SET);
  SetTicket(ticket);
  SetType(OrderType());
  SetSymbol(OrderSymbol());
  SetLot(OrderLots());
  SetOpenPrice(OrderOpenPrice());
  SetSL(OrderStopLoss());
  SetTP(OrderTakeProfit());
  SetTimeLocal(TimeLocal());
  SetTimeServer(TimeCurrent());
    
  bool res = Write();
  int err = ErrorCode();
  if (err == -1) {
    Print("*** ", ErrorMsg(), " ***");
    return (false);
  }
  
  return (true);
}

bool CheckModified(int ind, int ticket)
{
  if (ind < 0 || ind >= COUNT) return (false);
    
  if (PriceO[ind] == OrderOpenPrice() && 
      SL[ind] == OrderStopLoss() &&
      TP[ind] == OrderTakeProfit()) return (true);
       
  PriceO[ind] = OrderOpenPrice();
  SL[ind] = OrderStopLoss();
  TP[ind] = OrderTakeProfit();


  SetCmd(MODIFY);
  SetTicket(ticket);
  SetType(OrderType());
  SetSymbol(OrderSymbol());
  SetLot(OrderLots());
  SetOpenPrice(OrderOpenPrice());
  SetSL(OrderStopLoss());
  SetTP(OrderTakeProfit());
  SetTimeLocal(TimeLocal());
  SetTimeServer(TimeCurrent());
    
  bool res = Write();
  int err = ErrorCode();
  if (err == -1) {
    Print("*** ", ErrorMsg(), " ***");
    return (false);
  }
  
  return (true);
}

void RemoveOrder(int ind, int ticket)
{
  if (ind < 0 || ind >= COUNT) return (false);

  for (int i=ind; i<COUNT-1; i++) {
    Ticket[i] = Ticket[i+1];
    Type[i] = Type[i+1];
    Sym[i] = Sym[i+1];
    Lot[i] = Lot[i+1];
    PriceO[i] = PriceO[i+1];
    SL[i] = SL[i+1];
    TP[i] = TP[i+1];
  }
  COUNT--;
    
  SetCmd(CLOSE);
  SetTicket(ticket);
  SetType(OrderType());
  SetSymbol(OrderSymbol());
  SetLot(OrderLots());
  SetOpenPrice(OrderOpenPrice());
  SetSL(OrderStopLoss());
  SetTP(OrderTakeProfit());
  SetClosePrice(OrderClosePrice());
  SetTimeLocal(TimeLocal());
  SetTimeServer(TimeCurrent());
 
    
  bool res = Write();
  int err = ErrorCode();
  if (err == -1) {
    Print("*** ", ErrorMsg(), " ***");
    return (false);
  }
  
  return (true);
}